/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2020-01-16
 **/
!(function () {
    /*定义个引入JS的前端方法*/
    var JsManagers = [];
    $.extend(Dec.Utils,{
        getDataFactoryInitConfig:function (callback) {
            Dec.reqGet("/v10/hugh/factory/tabledata/config",{},callback);
        },
        createJsManager:function(pluginId, root){
            if( JsManagers[pluginId] ){
                return JsManagers[pluginId];
            }
            var manager = {
                id:pluginId,
                root:root,
                js:[],
                $base:$('script[src*="pluginId='+pluginId+'"]'),
                importJs:function (path) {
                    var self = this;
                    var importSingle = function (item) {
                        if( self.js[item] ){
                            return;
                        }
                        self.js[item]=true;
                        var $js = $("<script/>").attr("type","text/javascript")
                            .attr("src",Dec.fineServletURL+"/file?path="+self.root+item+"&type=plain&parser=dynamic&pluginId="+self.id+"&_t="+new Date().getTime());
                        self.$base.before($js);
                    };
                    BI.$.each(path, function(i, item) {
                        importSingle(item);
                    });
                }
            };
            JsManagers[pluginId] = manager;
            return manager;
        }
    });
    var JsManager = Dec.Utils.createJsManager("com.tptj.plugin.hg.tabledata.factory.v10"
        ,"com/tptj/plugin/hg/tabledata/factory/js/");

    JsManager.importJs(["factory.js",
        "factory.model.js",
        "expandable.panel.js",
        "expandable.panel.model.js",
        "expandable.node.js",
        "expander.node.checkbox.js"]);

    $.extend(DecCst.DataSet.Type,{FACTORY:"factory"});
    BI.config("dec.provider.data.set", function (provider) {
        provider.registerDataSetType({
            value: DecCst.DataSet.Type.FACTORY,
            text: BI.i18nText("Plugin-Dec-Data_Set_Factory"),
            cardType: "dec.data.set.type.factory",
            iconCls: "management-maintenance-cloud-font"
        });
    });

})();